<template>
    <div class="wrapper no-global-filters">
        <div class="chart-list">
            <div class="chart medium-width">
                <div class="chart-title no-filter">
                    <h3>Overview of Groups with Interactive Stages marked</h3>
                </div>
                <div class="chart-visualization">
                    <table class="text-center">
                        <thead>
                        <tr>
                            <th>Group</th>
                            <th>Application</th>
                            <th>Texturing</th>
                            <th>Lighting</th>
                            <th>Rasterization</th>
                        </tr>
                        </thead>
                        <tbody>
                        <tr v-for="(variant, key) in interactive">
                            <td>
                                {{key}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[0] === true, 'color-red': variant[0] === false}">
                                {{variant[0] === true ? "✔" : "X"}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[1] === true, 'color-red': variant[1] === false}">
                                {{variant[1] === true ? "✔" : "X"}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[2] === true, 'color-red': variant[2] === false}">
                                {{variant[2] === true ? "✔" : "X"}}
                            </td>
                            <td class="bold"
                                :class="{'color-green': variant[3] === true, 'color-red': variant[3] === false}">
                                {{variant[3] === true ? "✔" : "X"}}
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title no-filter">
                    <h3>Distribution of Groups (without incomplete participations)</h3>
                </div>
                <div class="chart-visualization">
                    <apexchart height="100%" :options="getGroupCountsChartOptions()" :series="getGroupCounts()" @click="getGroupCountsChartOptions().chart.events.click" @dataPointSelection="handleSelection"></apexchart>
                </div>
            </div>
            <div class="chart small-width">
                <div class="chart-title no-filter">
                    <h3>Incomplete Participations (in % of total participations)</h3>
                </div>
                <div class="chart-visualization single-line">
                    {{toPercentage(getIncompleteParticipationRelative())}}%
                </div>
            </div>
            <div class="chart medium-large-width medium-large-height">
                <div class="chart-title">
                    <h3>Participant Positions</h3>
                    <p>red square = Position of Kyle, black circle = Position of the coordinate system used to introduce TRS-matrices</p>
                </div>
                <div class="chart-visualization">
                    <!--apexchart :series="loadPositions()" :options="getHeatmapOptions()"></apexchart-->
                    <svg height="100%" width="100%" :viewBox="getPositionViewBox()">
                        <g v-for="(value, x) in loadPositions()">
                            <rect v-for="(valueY, y) in value" :x="x" :y="y" width="1" height="1" :fill="getColorGradient(valueY)" />
                        </g>
                        <rect :x="kylePosition[0]" :y="kylePosition[1]" width="1" height="1" fill="red" />
                        <circle :cx="coordinateSystem[0]" :cy="coordinateSystem[1]" r="0.5" fill="black" />
                    </svg>
                </div>
            </div>
            <div class="chart medium-large-width medium-large-height">
                <div class="chart-title">
                    <h3>Evaluation Immersion (avg. 5% - 95%)</h3>
                </div>
                <div class="chart-visualization">
                    <HorizontalBoxPlotChart :dataset="activeDataSet"
                                            :fields="getSurveyKeys('immersion')"
                                            :labels="getSurveyLabels('immersion')"
                                            :min="1"
                                            :max="9"
                                            :s1="40"
                                            :q1="50"
                                            :q3="50"
                                            :s3="60">

                    </HorizontalBoxPlotChart>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import interactive from "../data/interactive.json";
import endingTimes from "../data/ending_times.json";
import incomplete from "../data/incomplete.json";
import positions from "../data/positions.json";

import HorizontalBoxPlotChart from "@/components/HorizontalBoxPlotChart.vue";

import {type Ref, ref} from "vue";

const variants = ["A", "B", "C", "D", "E", "F"];

const filterOptions = {
    group: ["A", "B", "C", "D", "E", "F"],
    platform: ["EduXR:VR", "EduXR:Desktop"],
    time_application: {
        min: 0,
        max: 60
    },
    time_texturing: {
        min: 0,
        max: 60
    },
    time_lighting: {
        min: 0,
        max: 60
    },
    time_rasterization: {
        min: 0,
        max: 60
    }
}

const activeFilters = ref({
    group: ["A", "B", "C", "D", "E", "F"],
    platform: ["EduXR:VR", "EduXR:Desktop"],
    time_application: [0, 60],
    time_texturing: [0, 60],
    time_lighting: [0, 60],
    time_rasterization: [0, 60],
})

let activeDataSet : Ref<any[]> = ref([]);

function getPlatformBase(platform : string) {
    const platformParts = platform.split(":");

    return platformParts[0] + ":" + platformParts[1];
}

function updateFilters() {
    let dataset = Object.values(endingTimes);

    // Filter by group
    dataset = dataset.filter(dataElement => activeFilters.value.group.includes(dataElement.group));

    // Filter by platform
    dataset = dataset.filter(dataElement => activeFilters.value.platform.includes(getPlatformBase(dataElement.platform)))

    // Filter by application timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_application[0] <= dataElement.time_application && dataElement.time_application <= activeFilters.value.time_application[1])

    // Filter by texturing timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_texturing[0] <= dataElement.time_texturing && dataElement.time_texturing <= activeFilters.value.time_texturing[1])

    // Filter by lighting timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_lighting[0] <= dataElement.time_lighting && dataElement.time_lighting <= activeFilters.value.time_lighting[1])

    // Filter by rasterization timings
    dataset = dataset.filter(dataElement => activeFilters.value.time_rasterization[0] <= dataElement.time_rasterization && dataElement.time_rasterization <= activeFilters.value.time_rasterization[1])

    activeDataSet.value = dataset;
}

updateFilters();

let viewBox = "0 0 1 1";

const kylePosition = [0, 1.517]
const coordinateSystem = [-2.06, 1.41]

let highestValue = 0;

function getColorGradient(value) {
    if(value === 0) {
        return `rgba(255, 0, 0, 0)`;
    }
    return `rgba(30, 144, 255, ${value / highestValue})`;
}

function loadPositions() {
    let positionDataset : any[] = [];

    let minX = Number.MAX_VALUE;
    let maxX = Number.MIN_VALUE;

    let minZ = Number.MAX_VALUE;
    let maxZ = Number.MIN_VALUE;

    for(let positionObject of Object.values(positions)) {
        for(let timestampPosition of Object.values(positionObject.position)) {
            positionDataset.push(timestampPosition);

            if(timestampPosition[0] < minX) {
                minX = <number>timestampPosition[0];
            }

            if(timestampPosition[0] > maxX) {
                maxX = <number>timestampPosition[0];
            }

            if(timestampPosition[2] < minZ) {
                minZ = <number>timestampPosition[2];
            }

            if(timestampPosition[2] > maxZ) {
                maxZ = <number>timestampPosition[2];
            }
        }
    }

    const xyMap = {};

    for(let x = Math.floor(minX); x < Math.ceil(maxX); x ++) {
        xyMap[x] = {};
        for(let z = Math.floor(minZ); z < Math.floor(maxX); z++) {
            xyMap[x][z] = 0;
        }
    }

    for(let positionData of positionDataset) {
        xyMap[Math.floor(positionData[0])][Math.round(positionData[2])] ++;
    }

    const series = [];
    const xyMapLog = {};

    for(let x in xyMap) {
        xyMapLog[x] = {};
        for(let z in xyMap[x]) {
            const res = xyMap[x][z] === 0 ? 0 : Math.log2(xyMap[x][z]);
            xyMapLog[x][z] = res;

            if(res > highestValue) {
                highestValue = res;
            }
        }
    }

    viewBox = `${minX} ${minZ} ${maxX - minX} ${maxZ - minZ}`;

    return xyMapLog;
}

loadPositions();

function getPositionViewBox() {
    return viewBox;
}

function isGroupFiltered(variant) {
    return activeFilters.value.group.includes(variant);
}

function triggerGroupFilter(variant) {
    if(isGroupFiltered(variant)) {
        activeFilters.value.group.splice(activeFilters.value.group.indexOf(variant), 1);
    } else {
        activeFilters.value.group.push(variant);
    }

    updateFilters();
}

function isPlatformFiltered(platform) {
    return activeFilters.value.platform.includes(platform);
}

function triggerPlatformFilter(platform) {
    if(isPlatformFiltered(platform)) {
        activeFilters.value.platform.splice(activeFilters.value.platform.indexOf(platform), 1);
    } else {
        activeFilters.value.platform.push(platform);
    }

    updateFilters();
}

function getGroupCountsChartOptions() {
    return {
        chart: {
            type: 'donut',
            height: "100%",
            events: {
                click: function(event, chartContext, config) {
                    console.log("CLICK", event, chartContext, config)
                }
            }
        },
        colors: ['#8931EF', '#F2CA19', '#FF00BD', '#0057E9', '#87E911', '#E11845'],
        labels: variants.map(item => "Variant " + item),
        dataLabels: {
            formatter: function(val, { seriesIndex, w }) {
                return w.config.series[seriesIndex];
            }
        }
    };
}

function getHeatmapOptions() {
    return {
        chart: {
            height: 350,
            type: 'heatmap',
        },
        dataLabels: {
            enabled: false
        },
        colors: ["#008FFB"],
        title: {
            text: 'HeatMap Chart (Single color)'
        }
    };
}

function getGroupCounts() {
    const counts = [0, 0, 0, 0, 0, 0];

    for(let endingTime of Object.values(endingTimes)) {
        counts[variants.indexOf(endingTime.group)] += 1;
    }

    return counts;
}

function handleSelection(event, chartContext, config) {
    console.log("POINT SELECT", config.dataPointIndex)
}

function toPercentage(value: number) {
    return Math.round(value * 10000) / 100;
}

function getPercentile(data, percentile) {
    const index = (percentile/100) * data.length;
    let result;

    if (Math.floor(index) == index) {
        result = (data[(index-1)] + data[index])/2;
    } else {
        result = data[Math.floor(index)];
    }

    return result;
}

function getIncompleteParticipationRelative() {
    return incomplete.length / Object.keys(endingTimes).length;
}

function mergeArrays(array1: any[], array2: any[], includeArray1 = true, includeArray2 = false) : any[] {
    if(includeArray1 && includeArray2) {
        return Array.from([...array1, ...array2]);
    }
    if(includeArray1 && !includeArray2) {
        return [...array1];
    }
    if(!includeArray1 && includeArray2) {
        return [...array2];
    }
    return [];
}

const surveyResultMappings = {
    immersion: {
        "Please indicate to what extent you agree with each statement: [The visual aspects made me feel part of the virtual environment.]": "The visual aspects made me feel part of the virtual environment.",
        "Please indicate to what extent you agree with each statement: [The feeling of moving around in the virtual environment was convincing.]": "The feeling of moving around in the virtual environment was convincing.",
        "Please indicate to what extent you agree with each statement: [I was immersed in the virtual environment.]": "I was immersed in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I felt stimulated by the virtual environment.]": "I felt stimulated by the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I was so absorbed in the virtual environment that I didn't notice what was happening around me.]": "I was so absorbed in the virtual environment that I didn't notice what was happening around me.",
        "Please indicate to what extent you agree with each statement: [I was so immersed in the virtual environment, as if I were in the game instead of just controlling it and looking at it from the outside.]": "I was so immersed in the virtual environment, as if I were in the game instead of just controlling it and looking at it from the outside.",
        "Please indicate to what extent you agree with each statement: [I felt physically present in the virtual environment.]": "I felt physically present in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [I was so absorbed in the virtual environment that I lost my sense of time.]": "I was so absorbed in the virtual environment that I lost my sense of time.",
        "Please indicate to what extent you agree with each statement: [Time seemed to pass differently than it normally does.]": "Time seemed to pass differently than it normally does.",
        "Please indicate to what extent you agree with each statement: [Time seemed to pass faster.]": "Time seemed to pass faster.",
        "Please indicate to what extent you agree with each statement: [ I lost my sense of time.]": "I lost my sense of time.",
        "Please indicate to what extent you agree with each statement: [ I didn't care what others thought of me.]": "I didn't care what others thought of me.",
        "Please indicate to what extent you agree with each statement: [ I felt like I was experiencing an exciting moment.]": "I felt like I was experiencing an exciting moment.",
        "Please indicate to what extent you agree with each statement: [ I felt at ease with the experience.]": "I felt at ease with the experience.",
        "Please indicate to what extent you agree with each statement: [When I mention the experience in the virtual world, I want to share my impressions about it.]": "When I mention the experience in the virtual world, I want to share my impressions about it.",
        "Please indicate to what extent you agree with each statement: [ I enjoyed being in the virtual environment.]": "I enjoyed being in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [It was so exciting that I could have stayed in the virtual environment for hours.]": "It was so exciting that I could have stayed in the virtual environment for hours.",
        "Please indicate to what extent you agree with each statement: [ I felt like I was being distracted to reduce my discomfort.]": "I felt like I was being distracted to reduce my discomfort.",
        "Please indicate to what extent you agree with each statement: [I found my mind drifting in the virtual environment.]": "I found my mind drifting in the virtual environment.",
        "Please indicate to what extent you agree with each statement: [When my actions were going well, I felt like I was in a frenzy.]": "When my actions were going well, I felt like I was in a frenzy.",
        "Please indicate to what extent you agree with each statement: [While I was using the controllers/headset, time dragged.]": "While I was using the controllers/headset, time dragged.",
    }
}

function getSurveyKeys(category) {
    return Object.keys(surveyResultMappings[category]);
}

function getSurveyLabels(category) {
    return Object.values(surveyResultMappings[category]);
}
</script>